;~ SnapToScreen System for AutoIt
;~ Author : Heddy "The_Blade" DRISSA - 21/04/2008

#include-once
#include <WinAPI.au3>
#include <array.au3>

AutoItSetOption("WinTitleMatchMode", 4)

Global $SnapOffset
Global $SnapOtherWindows

Func _SnapToScreen($bActive = True, $bSnapOtherWindows = False, $iOffset = 10)
	GUIRegisterMsg($WM_WINDOWPOSCHANGING, "")
	If $bActive = True Then
		$SnapOffset = $iOffset
		$SnapOtherWindows = $bSnapOtherWindows
		GUIRegisterMsg($WM_WINDOWPOSCHANGING, "_WM_WINDOWPOSCHANGING")
	EndIf
EndFunc

Func _WM_WINDOWPOSCHANGING($hWnd, $Msg, $wParam, $lParam)
;~ 	On recupere les informations de la fenetre (Position Gauche, Haute, Largeur et Hauteur)
	Local $newWinPos    = DllStructCreate("uint;uint;int;int;int;int;uint", $lParam)
	Local $newWinLeft   = DllStructGetData($newWinPos, 3)
	Local $newWinTop    = DllStructGetData($newWinPos, 4)
	Local $newWinWidth  = DllStructGetData($newWinPos, 5)
	Local $newWinHeight = DllStructGetData($newWinPos, 6)

;~ 	Si rien ne se passe ?... Alors on ne fait rien !!
	If ($newWinLeft = 0) And ($newWinTop = 0) Then Return 0

;~ 	On recupere les informations de la barre des taches en temps reel (Position Gauche, Haute, Largeur et Hauteur)
	Local $ShellTrayHwnd   =  WinGetHandle("classname=Shell_TrayWnd")
	Local $ShellRect = _WinAPI_GetWindowRect($ShellTrayHwnd)
	Local $ShellTrayLeft = DllStructGetData($ShellRect, 1)
	Local $ShellTrayTop = DllStructGetData($ShellRect, 2)
	Local $ShellTrayHeight = _WinAPI_GetWindowHeight($ShellTrayHwnd)
	Local $ShellTrayWidth  = _WinAPI_GetWindowWidth($ShellTrayHwnd)

	If $SnapOtherWindows Then

	;~ 	On recupere chaque autre fenetre qu'on aurait eventuellement cre
		Local $ActiveWindows = WinList("classname=AutoIt v3 GUI")
	;~ 	On Teste chaque fenetre
		For $i = 1 To $ActiveWindows[0][0]
	;~ 		Si la fenetre n'est pas celle qu'on deplace et si elle est visible ...
			If ($ActiveWindows[$i][1] <> $hWnd) And (_WinAPI_IsWindowVisible($ActiveWindows[$i][1])) Then
	;~ 			On recupere ses infromations (Position Gauche, Haute, Largeur et Hauteur)
				Local $WindowRect   = _WinAPI_GetWindowRect($ActiveWindows[$i][1])
				Local $WindowLeft   = DllStructGetData($WindowRect, 1)
				Local $WindowTop    = DllStructGetData($WindowRect, 2)
				Local $WindowWidth  = _WinAPI_GetWindowWidth($ActiveWindows[$i][1])
				Local $WindowHeight = _WinAPI_GetWindowHeight($ActiveWindows[$i][1])

				Local $NearHWindow = False
				Local $NearVWindow = False

	;~ 			On determine si la fenetre est situe en haut, en bas, a droite ou a gauche de la fenetre que l'on deplace ...
				If ($newWinTop >= $WindowTop) And ($newWinTop <= $WindowTop + $WindowHeight) Then $NearHWindow = True
				If ($newWinTop + $newWinHeight >= $WindowTop) And ($newWinTop + $newWinHeight <= $WindowTop + $WindowHeight) Then $NearHWindow = True
				If ($newWinTop <= $WindowTop) And ($newWinTop + $newWinHeight >= $WindowTop + $WindowHeight) then $NearHWindow = True
				If ($newWinLeft >= $WindowLeft) And ($newWinLeft <= $WindowLeft + $WindowWidth) Then $NearVWindow = True
				If ($newWinLeft + $newWinWidth >= $WindowLeft) And ($newWinLeft + $newWinWidth <= $WindowLeft + $WindowWidth) Then $NearVWindow = True
				If ($newWinLeft <= $WindowLeft) And ($newWinLeft + $newWinWidth >= $WindowLeft + $WindowWidth) then $NearVWindow = True

	;~ 			En fonction de la position de la fenetre proche de la notre, nous recalculons les dimensions...
				If $NearHWindow Then
					If ($newWinLeft >= $WindowLeft + $WindowWidth - $SnapOffset) And ($newWinLeft <= $WindowLeft + $WindowWidth + $SnapOffset) Then DllStructSetData($newWinPos, 3, $WindowLeft + $WindowWidth)
					If ($newWinLeft + $newWinWidth <= $WindowLeft + $SnapOffset) And ($newWinLeft + $newWinWidth >= $WindowLeft - $SnapOffset) Then DllStructSetData($newWinPos, 3, $WindowLeft - $newWinWidth)
				EndIf

				If $NearVWindow Then
					If ($newWinTop >= $WindowTop + $WindowHeight - $SnapOffset) And ($newWinTop <= $WindowTop + $WindowHeight + $SnapOffset) Then DllStructSetData($newWinPos, 4, $WindowTop + $WindowHeight)
					If ($newWinTop + $newWinHeight >= $WindowTop - $SnapOffset) And ($newWinTop + $newWinHeight <= $WindowTop + $SnapOffset) Then DllStructSetData($newWinPos, 4, $WindowTop - $newWinHeight)
				EndIf
			EndIf
		Next
	EndIf

;~ 	On initialise les variables qui nous serviront pour determiner la position de la barre des taches et les nouvelles coordonnes de la fenetre
	Local $n1 = 0
	Local $n2 = 0
	Local $n3 = 0
	Local $n4 = 0

;~ 	Quelle est la position de la barre des taches ?
;~ 	On essai par la meme occasion de prevenir tout changement de theme de bureau
;~ 	En Haut ou en Bas ?
	If ($ShellTrayWidth > $ShellTrayHeight) Then
		If ($ShellTrayTop > @DesktopHeight / 2) Then
;~ 			-> La barre des taches est en bas
			$n1 = $ShellTrayHeight
		Else
;~ 			-> La barre des taches est en haut
			$n2 = $ShellTrayHeight
		EndIf
	Else
;~ 		A Droite ou a Gauche ?
		If ($ShellTrayLeft < @DesktopWidth / 2) Then
;~ 			-> La barre des taches est  gauche
			$n3 = $ShellTrayWidth
		Else
;~ 			-> La Barre des taches est  droite
			$n4 = $ShellTrayWidth
		EndIf
	EndIf

;~ 	On redefini les nouvelles positions de maniere  accrocher l'ecran :
;~ 	Position Gauche
	If ($newWinLeft >= $n3 - $SnapOffset) And ($newWinLeft <= $n3 + $SnapOffset) Then DllStructSetData($newWinPos, 3, $n3)
;~ 	Position Haute
	If ($newWinTop >= $n2 - $SnapOffset) And ($newWinTop <= $n2 + $SnapOffset) Then DllStructSetData($newWinPos, 4, $n2)
;~ 	Largeur
	If ($newWinLeft + $newWinWidth >= @DesktopWidth - $n4 - $SnapOffset) And ($newWinLeft + $newWinWidth <= @DesktopWidth - $n4 + $SnapOffset) Then DllStructSetData($newWinPos, 3, @DesktopWidth - $newWinWidth - $n4)
;~ 	Hauteur
	If ($newWinTop + $newWinHeight >= @DesktopHeight - $n1 - $SnapOffset) And ($newWinTop + $newWinHeight <= @DesktopHeight - $n1 + $SnapOffset) Then DllStructSetData($newWinPos, 4, @DesktopHeight - $newWinHeight - $n1)

	Return 0
EndFunc
